/*
Secure Digital Card Interface for the MSP430
written by
F. Foust
Dept. of Electrical and Computer Engineering
Michigan State University, 2004
*/

#ifndef SD_H
#define SD_H
#include "spi_sd.h"
#define SD_BLOCKSIZE 512
#define SD_BLOCKSIZE_NBITS 9

extern sd_context_t sdc;
/* User functions */
int sd_card_present();
int sd_initialize(sd_context_t *sdc);
int sd_read_block(  sd_context_t *sdc, DWORD blockaddr, BYTE* data );
int sd_write_block (sd_context_t *sdc, u32 blockaddr, const unsigned char *data);
void sd_wait_notbusy (sd_context_t *sdc);
/* Internal functions, used for SD card communications. */
void sd_packarg(unsigned char *argument, u32 value);
int sd_set_blocklen (sd_context_t *sdc, u32 length);
int sd_send_command(sd_context_t *sdc,
unsigned char cmd, unsigned char response_type,
unsigned char *response, unsigned char *argument);
void sd_delay(char number);

int do_sd_initialize( sd_context_t *sdc );

#endif
